// oCADis (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "object.h"

using namespace os;
using namespace std;

Object :: Object()
{
	m_Selected = false;
	m_Layer = NULL;
}

Object :: ~Object()
{
}

void Object :: Erase( Canvas* canvas )
{
}

void Object :: Draw( Canvas* canvas, bool save_background, bool update_server )
{
}

void Object :: Draw( Canvas* canvas, Transform& transform, bool save_background, bool update_server )
{
}

void Object :: DoTransform( Transform& transform )
{
}

Rect Object :: GetBounds()
{
	return Rect();
}

bool Object :: HitCheck( Point coord, double sens )
{
	return false;
}

Object* Object :: Duplicate()
{
	return this;
}

void Object :: SetSelected( bool sel )
{
	m_Selected = sel;
}

bool Object :: IsSelected()
{
	return m_Selected;
}

void Object :: SetLayer( Layer* layer )
{
	m_Layer = layer;
	m_Style.SetLayer( layer );
}

Layer* Object :: GetLayer()
{
	return m_Layer;
}

bool Object :: SetProperty( int which, os::Variant& value )
{
	return false;
}

bool Object :: GetProperty( int which, os::Variant& value )
{
	return false;
}

bool Object :: GetSnapPoint( int type, Point p, std::vector< os::Point >& list )
{
	return false;
}

String Object :: SaveAttributes()
{
	return m_Style.SaveAttributes();
}

String Object :: Save()
{
	return String( "object" );
}

